Disable MySQL Service on Ubuntu

Change-Id: Ia49437d20ae3bfff2e3f4b2506bc285b0a2e34e5
Closes-Bug: 1347007
This commit is contained in:
Sergii Golovatiuk 2014-07-22 16:33:11 +00:00
parent c935771840
commit 8b73ee390e
4 changed files with 27 additions and 496 deletions

View File

@ -1,485 +0,0 @@
#!/bin/bash
# Copyright Abandoned 1996 TCX DataKonsult AB & Monty Program KB & Detron HB
# This file is public domain and comes with NO WARRANTY of any kind
# MySQL daemon start/stop script.
# Usually this is put in /etc/init.d (at least on machines SYSV R4 based
# systems) and linked to /etc/rc3.d/S99mysql and /etc/rc0.d/K01mysql.
# When this is done the mysql server will be started when the machine is
# started and shut down when the systems goes down.
# Comments to support chkconfig on RedHat Linux
# chkconfig: 2345 64 36
# description: A very fast and reliable SQL database engine.
# Comments to support LSB init script conventions
### BEGIN INIT INFO
# Provides: mysql
# Required-Start: $local_fs $network $remote_fs
# Should-Start: ypbind nscd ldap ntpd xntpd
# Required-Stop: $local_fs $network $remote_fs
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
# Short-Description: start and stop MySQL
# Description: MySQL is a very fast and reliable SQL database engine.
### END INIT INFO
# If you install MySQL on some other places than /usr, then you
# have to do one of the following things for this script to work:
#
# - Run this script from within the MySQL installation directory
# - Create a /etc/my.cnf file with the following information:
# [mysqld]
# basedir=<path-to-mysql-installation-directory>
# - Add the above to any other configuration file (for example ~/.my.ini)
# and copy my_print_defaults to /usr/bin
# - Add the path to the mysql-installation-directory to the basedir variable
# below.
#
# If you want to affect other MySQL variables, you should make your changes
# in the /etc/my.cnf, ~/.my.cnf or other MySQL configuration files.
# If you change base dir, you must also change datadir. These may get
# overwritten by settings in the MySQL configuration files.
basedir=
datadir=
# Default value, in seconds, afterwhich the script should timeout waiting
# for server start.
# Value here is overriden by value in my.cnf.
# 0 means don't wait at all
# Negative numbers mean to wait indefinitely
service_startup_timeout=900
# Lock directory for RedHat / SuSE.
lockdir='/var/lock/subsys'
lock_file_path="$lockdir/mysql"
# The following variables are only set for letting mysql.server find things.
# Set some defaults
mysqld_pid_file_path=
if test -z "$basedir"
then
basedir=/usr
bindir=/usr/bin
if test -z "$datadir"
then
datadir=/var/lib/mysql
fi
sbindir=/usr/sbin
libexecdir=/usr/sbin
else
bindir="$basedir/bin"
if test -z "$datadir"
then
datadir="$basedir/data"
fi
sbindir="$basedir/sbin"
libexecdir="$basedir/libexec"
fi
# datadir_set is used to determine if datadir was set (and so should be
# *not* set inside of the --basedir= handler.)
datadir_set=
#
# Use LSB init script functions for printing messages, if possible
#
lsb_functions="/lib/lsb/init-functions"
if test -f $lsb_functions ; then
. $lsb_functions
else
log_success_msg()
{
echo " SUCCESS! $@"
}
log_failure_msg()
{
echo " ERROR! $@"
}
fi
PATH="/sbin:/usr/sbin:/bin:/usr/bin:$basedir/bin"
export PATH
mode=$1 # start or stop
[ $# -ge 1 ] && shift
other_args="$*" # uncommon, but needed when called from an RPM upgrade action
# Expected: "--skip-networking --skip-grant-tables"
# They are not checked here, intentionally, as it is the resposibility
# of the "spec" file author to give correct arguments only.
case `echo "testing\c"`,`echo -n testing` in
*c*,-n*) echo_n= echo_c= ;;
*c*,*) echo_n=-n echo_c= ;;
*) echo_n= echo_c='\c' ;;
esac
parse_server_arguments() {
for arg do
case "$arg" in
--basedir=*) basedir=`echo "$arg" | sed -e 's/^[^=]*=//'`
bindir="$basedir/bin"
if test -z "$datadir_set"; then
datadir="$basedir/data"
fi
sbindir="$basedir/sbin"
libexecdir="$basedir/libexec"
;;
--datadir=*) datadir=`echo "$arg" | sed -e 's/^[^=]*=//'`
datadir_set=1
;;
--pid-file=*) mysqld_pid_file_path=`echo "$arg" | sed -e 's/^[^=]*=//'` ;;
--service-startup-timeout=*) service_startup_timeout=`echo "$arg" | sed -e 's/^[^=]*=//'` ;;
esac
done
}
wait_for_pid () {
verb="$1" # created | removed
pid="$2" # process ID of the program operating on the pid-file
pid_file_path="$3" # path to the PID file.
i=0
avoid_race_condition="by checking again"
while test $i -ne $service_startup_timeout ; do
case "$verb" in
'created')
# wait for a PID-file to pop into existence.
test -s "$pid_file_path" && i='' && break
;;
'removed')
# wait for this PID-file to disappear
test ! -s "$pid_file_path" && i='' && break
;;
*)
echo "wait_for_pid () usage: wait_for_pid created|removed pid pid_file_path"
exit 1
;;
esac
# if server isn't running, then pid-file will never be updated
if test -n "$pid"; then
if kill -0 "$pid" 2>/dev/null; then
: # the server still runs
else
# The server may have exited between the last pid-file check and now.
if test -n "$avoid_race_condition"; then
avoid_race_condition=""
continue # Check again.
fi
# there's nothing that will affect the file.
log_failure_msg "The server quit without updating PID file ($pid_file_path)."
rm -f "$pid_file_path"
return 0 # not waiting any more.
fi
fi
echo $echo_n ".$echo_c"
i=`expr $i + 1`
sleep 1
done
if test -z "$i" ; then
log_success_msg
return 0
else
log_failure_msg
return 1
fi
}
# Get arguments from the my.cnf file,
# the only group, which is read from now on is [mysqld]
if test -x ./bin/my_print_defaults
then
print_defaults="./bin/my_print_defaults"
elif test -x $bindir/my_print_defaults
then
print_defaults="$bindir/my_print_defaults"
elif test -x $bindir/mysql_print_defaults
then
print_defaults="$bindir/mysql_print_defaults"
else
# Try to find basedir in /etc/my.cnf
conf=/etc/my.cnf
print_defaults=
if test -r $conf
then
subpat='^[^=]*basedir[^=]*=\(.*\)$'
dirs=`sed -e "/$subpat/!d" -e 's//\1/' $conf`
for d in $dirs
do
d=`echo $d | sed -e 's/[ ]//g'`
if test -x "$d/bin/my_print_defaults"
then
print_defaults="$d/bin/my_print_defaults"
break
fi
if test -x "$d/bin/mysql_print_defaults"
then
print_defaults="$d/bin/mysql_print_defaults"
break
fi
done
fi
# Hope it's in the PATH ... but I doubt it
test -z "$print_defaults" && print_defaults="my_print_defaults"
fi
#
# Read defaults file from 'basedir'. If there is no defaults file there
# check if it's in the old (depricated) place (datadir) and read it from there
#
extra_args=""
if test -r "$basedir/my.cnf"
then
extra_args="-e $basedir/my.cnf"
else
if test -r "$datadir/my.cnf"
then
extra_args="-e $datadir/my.cnf"
fi
fi
parse_server_arguments `$print_defaults $extra_args mysqld server mysql_server mysql.server`
#
# Set pid file if not given
#
if test -z "$mysqld_pid_file_path"
then
mysqld_pid_file_path=$datadir/`hostname`.pid
else
case "$mysqld_pid_file_path" in
/* ) ;;
* ) mysqld_pid_file_path="$datadir/$mysqld_pid_file_path" ;;
esac
fi
case "$mode" in
'start')
# Start daemon
sleep 30
if pgrep "mysqld_safe|mysqld" 1>/dev/null
then
echo "There are other mysqld processes running. Exiting"
exit 0
fi
# Safeguard (relative paths, core dumps..)
cd $basedir
echo $echo_n "Starting MySQL"
if [ -f /tmp/wsrep-init-file ]; then
if test -x $bindir/mysqld_safe
then
# Give extra arguments to mysqld with the my.cnf file. This script
# may be overwritten at next upgrade.
$bindir/mysqld_safe --datadir="$datadir" --pid-file="$mysqld_pid_file_path" $other_args >/dev/null 2>&1 &
wait_for_pid created "$!" "$mysqld_pid_file_path"; return_value=$?
# Make lock for RedHat / SuSE
if test -w "$lockdir"
then
touch "$lock_file_path"
fi
exit $return_value
else
log_failure_msg "Couldn't find MySQL server ($bindir/mysqld_safe)"
fi
else
if [ "$(crm_attribute -t crm_config --name mysqlprimaryinit --query 2> /dev/null | awk -F\= '{print $4}')" = 'done' ] ; then
$bindir/mysqld_safe --datadir="$datadir" --pid-file="$mysqld_pid_file_path" $other_args >/dev/null 2>&1 &
wait_for_pid created "$!" "$mysqld_pid_file_path"; return_value=$?
sleep 90
WSREP_EPOCH=$(echo 'show status;' | mysql -u root | grep wsrep_protocol_version | awk '{print $2}')
WSREP_STATE=$(echo 'show status;' | mysql -u root | grep wsrep_cluster_status | awk '{print $2}')
if [ "$WSREP_STATE" = 'non-Primary' ]; then
WINNER_NODE=$(hostname)
MAX_EPOCH=$WSREP_EPOCH
crm_attribute -t crm_config --node $(hostname) --name mysqlepoch --update $WSREP_EPOCH
# Seems to be more or less legitimate solution explicitly for "datacenter power switch" situation:
# - first of all, more complex logic does not bring more precise knowledge of which node
# should be a master, because it related to such property as an epoch and user may simply
# decide to not start node which was online during entire disaster holding "bad" data.
# - five minutes are enough for man who turns servers in the rack and for crm to push significant
# percentage of the epoch values to the shared resource and not too large for such type of disaster at all.
sleep 300
# Check if someone already decided to declare himself master...
RAISED_MASTER=$(crm_attribute -t crm_config --name mysqlmaster --query 2> /dev/null | awk -F\= '{print $4}')
# ... and if nobody did:
CRM_ONLINE_NODES=( $(crm node list | grep -v \(offline\) | sed 's/\://g') )
for node in "${CRM_ONLINE_NODES[@]}" ; do
CUR_EPOCH=$(crm_attribute -t crm_config --node $node --name mysqlepoch --query 2> /dev/null | awk -F\= '{print $4}')
if [ -z "$CUR_EPOCH" ] ; then
echo "Skipping comparison with node $node"
else
if [ "$(echo ''$CUR_EPOCH' > '$MAX_EPOCH'' | bc)" -eq '1' ] ; then
WINNER_NODE=$node
MAX_EPOCH=$CUR_EPOCH
fi
fi
done
if [ "$RAISED_MASTER" != '1' ]; then
if [ "$WINNER_NODE" = "$(hostname)" ] ; then
crm_attribute -t crm_config --name mysqlmaster --update 1
echo "mysql: Assuming current node as a new master..."
kill `cat "$mysqld_pid_file_path"`
sleep 30
$bindir/mysqld_safe --datadir="$datadir" --pid-file="$mysqld_pid_file_path" --wsrep-cluster-address="gcomm://" $other_args >/dev/null 2>&1 &
wait_for_pid created "$!" "$mysqld_pid_file_path"; return_value=$?
crm_attribute -t crm_config --name mysqlmaster --delete
fi
else
echo "mysql: Master flag was already set, skipping our (probably legitimate yet) promotion"
kill `cat "$mysqld_pid_file_path"`
sleep 30
$bindir/mysqld_safe --datadir="$datadir" --pid-file="$mysqld_pid_file_path" $other_args >/dev/null 2>&1 &
wait_for_pid created "$!" "$mysqld_pid_file_path"; return_value=$?
fi
else
echo Nothing to do
fi
fi
fi
;;
'stop')
# Stop daemon. We use a signal here to avoid having to know the
# root password.
sleep 30
retry=0
if test -s "$mysqld_pid_file_path"
then
mysqld_pid=`cat "$mysqld_pid_file_path"`
else
mysqld_pid=`pidof mysqld`
fi
if (kill -0 $mysqld_pid 2>/dev/null)
then
echo $echo_n "Shutting down MySQL"
kill $mysqld_pid
# mysqld should remove the pid file when it exits, so wait for it.
wait_for_pid removed "$mysqld_pid" "$mysqld_pid_file_path"; return_value=$?
j=0
while test $j -ne 60 #wait a little bit for mysql to exit
do
if (kill -0 $mysqld_pid 2>/dev/null); then
j=$((j+1))
else
break
fi
sleep 1
done
if test $j -eq 10;
then
log_failure_msg "MySQL server process #$mysqld_pid failed to stop!"
return_value=1
fi
echo "Waiting for galera processes # `pidof mysqld` to finally exit."
j=0
while test $j -ne 30
do
if (kill -0 `pidof mysqld` 1>&2 2>/dev/null)
then
echo -n ".`pidof mysqld`"
kill `pidof mysqld`
sleep 2
else
echo
break
fi
done
if (kill -0 `pidof mysqld` 1>&2 2>/dev/null)
then
log_failure_msg "Not all galera processes exited"
return_value=1
fi
else
log_failure_msg "MySQL server process #$mysqld_pid is not running!"
rm "$mysqld_pid_file_path"
fi
# Delete lock for RedHat / SuSE
if test -f "$lock_file_path"
then
rm -f "$lock_file_path"
fi
exit $return_value
;;
'restart')
# Stop the service and regardless of whether it was
# running or not, start it again.
if $0 stop $other_args; then
$0 start $other_args
else
log_failure_msg "Failed to stop running server, so refusing to try to start."
exit 1
fi
;;
'reload'|'force-reload')
if test -s "$mysqld_pid_file_path" ; then
read mysqld_pid < "$mysqld_pid_file_path"
kill -HUP $mysqld_pid && log_success_msg "Reloading service MySQL"
touch "$mysqld_pid_file_path"
else
log_failure_msg "MySQL PID file could not be found!"
exit 1
fi
;;
'status')
# First, check to see if pid file exists
if test -s "$mysqld_pid_file_path" ; then
read mysqld_pid < "$mysqld_pid_file_path"
if kill -0 $mysqld_pid 2>/dev/null ; then
log_success_msg "MySQL running ($mysqld_pid)"
exit 0
else
log_failure_msg "MySQL is not running, but PID file exists"
exit 1
fi
else
# Try to find appropriate mysqld process
mysqld_pid=`pidof /usr/sbin/mysqld`
if test -z $mysqld_pid ; then
if test -f "$lock_file_path" ; then
log_failure_msg "MySQL is not running, but lock file ($lock_file_path) exists"
exit 2
fi
log_failure_msg "MySQL is not running"
exit 3
else
log_failure_msg "MySQL is running but PID file could not be found"
exit 0
fi
fi
;;
*)
# usage
basename=`basename "$0"`
echo "Usage: $basename {start|stop|restart|reload|force-reload|status} [ MySQL server options ]"
exit 1
;;
esac
exit 0

View File

@ -72,6 +72,7 @@ class galera (
$wait_timeout = $::galera::params::wait_timeout
$open_files_limit= $::galera::params::open_files_limit
$datadir=$::mysql::params::datadir
$service_name=$::galera::params::service_name
package { ['wget',
'perl']:
@ -136,7 +137,7 @@ class galera (
'RedHat' => '/var/lib/mysql/mysql.sock',
'Debian' => '/var/run/mysqld/mysqld.sock',
}
cs_resource { 'p_mysql':
cs_resource { "p_${service_name}":
ensure => present,
primitive_class => 'ocf',
provided_by => 'mirantis',
@ -165,13 +166,15 @@ class galera (
}
Anchor['galera'] ->
File['mysql-wss-ocf'] ->
Cs_resource['p_mysql'] ->
Service['mysql'] ->
Exec['wait-for-synced-state']
Service["${service_name}_stopped"] ->
Cs_resource["p_${service_name}"] ->
Service["${service_name}-service"] ->
Exec['wait-for-synced-state']
} else {
Anchor['galera'] ->
File['mysql-wss-ocf'] ->
Service['mysql']
Service["${service_name}_stopped"] ->
Service["${service_name}-service"]
}
file { 'mysql-wss-ocf':
@ -187,16 +190,26 @@ class galera (
Package['MySQL-server'] -> File['mysql-wss-ocf']
Package['galera'] -> File['mysql-wss-ocf']
service { 'mysql':
tweaks::ubuntu_service_override { "${service_name}":
package_name => 'MySQL-server',
}
service { "${service_name}_stopped":
ensure => 'stopped',
name => "${service_name}",
enable => false,
}
service { "${service_name}-service":
ensure => 'running',
name => 'p_mysql',
name => "p_${service_name}",
enable => true,
provider => 'pacemaker',
}
Service['mysql'] -> Anchor['galera-done']
Service["${service_name}-service"] -> Anchor['galera-done']
if $::galera_gcomm_empty == "true" {
if $::galera_gcomm_empty == 'true' {
#FIXME(bogdando): dirtyhack to pervert imperative puppet nature.
if $::mysql_log_file_size_real != $mysql_log_file_size {
# delete MySQL ib_logfiles, if log file size does not match the one
@ -251,7 +264,7 @@ class galera (
}
File['/tmp/wsrep-init-file'] ->
Service['mysql'] ->
Service["${service_name}-service"] ->
Exec['wait-initial-sync'] ->
Exec['wait-for-synced-state'] ->
Exec ['rm-init-file']

View File

@ -19,6 +19,7 @@ class galera::params {
$mysql_user = 'wsrep_sst'
$mysql_password = 'password'
$service_name = 'mysql'
#TODO(bogdando) remove code duplication for galera and mysql manifests to openstack::db in 'I' release
#limit buffer size to 10G
$buffer_size =

View File

@ -35,7 +35,9 @@ class mysql::password (
group => 'mysql',
}
Service['mysql'] -> Exec['set_mysql_rootpw']
Service <| title == 'mysql' |> -> Exec['set_mysql_rootpw']
Service <| title == 'mysql-service' |> -> Exec['set_mysql_rootpw']
Exec['set_mysql_rootpw'] -> File['mysql_password']
File <| title == $config_file |> -> File['mysql_password']
File <| title == '/etc/my.cnf' |> -> File['mysql_password']